/*       ͻ
             TITLE:  Xmodem test routines for Keil C Compiler      
          FILENAME:  Test_Xmodem.c                                 
          REVISION:  VER 0.0                                       
          REV.DATE:  22-01-04                                      
           ARCHIVE:                                                
            AUTHOR:  Copyright (c) 2004, Murray R.Van Luyn.        
         ͼ        */


#include "Test_Xmodem.h"


/*  ͻ
                         Public Function Implementation                  
    ͼ  */

/*  ͻ
                                                                         
                                    main()                               
                                                                         
                                                                         
                                                                         
    ͼ  */
void main(void)
{ 
    while (1)
    {
        while (!xmodem_tx());
    }
}


/*  ͻ
                                                                         
                               get_packet_data()                         
                                                                         
    ͼ  */
unsigned char get_packet_data(unsigned char xdata * packet_data_buffer)
{
    static char xdata print_buffer[PRINT_BUFFER_LENGTH] = {'\0'};
    static char xdata * print_buffer_pointer = print_buffer;
    static unsigned long count_1 = 0;
    static unsigned long count_2 = 0;
    static unsigned long count_3 = 0;
    unsigned char last_packet = 0;
    unsigned char index; 
    

    for (index = 0; index < PACKET_DATA_BUFFER_LENGTH; index++)
    {

        if ((*print_buffer_pointer == '\0') && (count_1 < MAX_COUNT))
        {

            // Typically this is where an app will do integration etc. 

            count_1 += COUNT_STEP;
            count_2 += COUNT_STEP * 2;
            count_3 += COUNT_STEP * 3;

            print_buffer_pointer = print_buffer;

            // sprintf() can take no more than 15 bytes in small model
            // a salient point!

            print_buffer_pointer += sprintf(print_buffer_pointer,
                         "Counter_1 = %3d ", (int)count_1);

            print_buffer_pointer += sprintf(print_buffer_pointer,
                         "Counter_2 = %3d ", (int)count_2);

            sprintf(print_buffer_pointer,
                         "Counter_3 = %3d \r\n", (int)count_3);

            print_buffer_pointer = print_buffer;
        }
   
        if (*print_buffer_pointer == '\0')
        {
            packet_data_buffer[index] = SPACE;    // pad with spaces
            last_packet = 1;            
        }
        else
        {
            packet_data_buffer[index] = *print_buffer_pointer; 
            print_buffer_pointer++;
        }
    
    }
    
    if (last_packet == 1)
    {
        count_1 = 0; // so we can do it all again
        count_2 = 0;
        count_3 = 0;
    }

    return last_packet;
}

