/*       ͻ
             TITLE:  Xmodem routines for Keil C Compiler           
          FILENAME:  Xmodem.h                                      
          REVISION:  VER 0.0                                       
          REV.DATE:  21-11-03                                      
           ARCHIVE:                                                
            AUTHOR:  Copyright (c) 2003, Murray R.Van Luyn.        
         ͼ        */


#ifndef XMODEM_H
#define XMODEM_H

#include "Sio_poll.h"

/*  ͻ
                                  Defined Constants                      
    ͼ  */
#define SOH       0x01
#define EOT       0x04
#define ACK       0x06
#define NAK       0x15
#define CAN       0x18
#define CTRL_Z    0x1a
#define SPACE     0x20
#define ASCII_C   0x43
#define PACKET_DATA_BUFFER_LENGTH 128
#define MAX_TX_TRY 3


/*  ͻ
                            Public Function Prototypes                   
    ͼ  */
extern unsigned char get_packet_data(unsigned char xdata * packet_data_buffer);
extern unsigned char xmodem_tx(void);


#endif
